--[[
-- table compatible library
-- version 1.0 (2007-09-12) later: 2006-04-04
-- table݊Cu
-- T|[g: table.sort

Author:
	silica as ~̐l
	http://winter.sgv417.jp/
From:
	Ȟ
	http://blog.livedoor.jp/aidev/
Document:
	http://pc3merchant.net/ai_antenna/index.php?Dev%2FLib%2Ftable.lua
--]]
if not table then	-- e[u table ֐ƂAւp
	
	local internal = {}	-- Ԃ̍Č
	
	table = {}
	
	function table.setn( t, n )
		if t.n then
			t.n = n
		else
			internal[ t ] = n
		end
	end
	
	function table.getn( t )
		if t.n then return t.n end
		if internal[ t ] then return internal[ t ] end
		local n = 0
		for i, v in ipairs( t ) do
			n = i
		end
		return n
	end
	
	function table.insert( t, pos, value )
		local n = table.getn( t )
		if not value then
			value = pos
			pos = n + 1	-- ftHgl
		else
			assert( pos >= 1 and pos <= n + 1 )	-- L͈͂`FbN
		end
		for i = n, pos, -1 do 	-- ̗vf炷
			t[i+1] = t[i]
		end
		t[ pos ] = value
		table.setn( t, n + 1 )
	end
	
	function table.remove( t, pos )
		local n = table.getn( t )
		assert( not pos or pos >= 1 and pos <= n )	-- L͈͂`FbN
		if not pos then pos = n end	-- ftHgl
		t[ pos ] = nil
		for i = pos, n, 1 do	-- t[n]  nil ŏ㏑
			t[i] = t[i+1]
		end
		table.setn( t, n - 1 )
	end
	
	function table.foreach( t, f )
		for k,v in pairs( t ) do
			local r = f( k, v )
			if r ~= nil then
				return r
			end
		end
	end
	
	function table.foreachi( t, f )
		for i = 1, table.getn( t ) do
			local r = f( i, t[i] )
			if r ~= nil then
				return r
			end
		end
	end

	function table.concat( t, sep, i, j )
		-- `FbN
		if(j == nil) then j = table.getn( t ) end
		if(i == nil) then i = 1 end
		if(i > j) then return "" end
		local str = ""
		for c = i, j do	-- e[uA
			str = str..sep..t[c]
		end
		return string.sub(str, string.len(sep)+1, string.len(str))
	end
end
